package MooseProgrammer;
use strict;
use warnings;
use Function::Parameters qw(:strict);
use Moose;

extends 'MoosePerson';
has 'skills' => (
  is       => 'rw',
  isa      => 'HashRef',
  default  => sub { return { java => 'ok' } },
);
method skills_as_string {          # additional method
	my $sk = $self->skills;
	my @str = map { sprintf( "%s:%s", $_, $sk->{$_} ) } sort(keys(%$sk));
	return "{" . join(", ", @str) . "}";
}
around 'as_string' => fun( $orig, $self ) {
	my $pers = $self->$orig(@_); $pers =~ s/ \)$//;
	my $skills = $self->skills_as_string;
	return "$pers, skills=$skills )";
};
1;
