package Person;
use strict;
use warnings;
use Function::Parameters qw(:strict);

my %default = (NAME=>"Shirley", SEX=>"f", AGE=>26);

# the object constructor
fun new( $class, %arg ) {
	my $obj      = bless( {}, $class );
	$obj->{NAME} = $arg{NAME} // $default{NAME};
	$obj->{SEX}  = $arg{SEX}  // $default{SEX};
	$obj->{AGE}  = $arg{AGE}  // $default{AGE};
	return $obj;
}

# get/set methods - set the value if given extra arg
method name( $value = undef ) {
	$self->{NAME} = $value if defined $value;
	return $self->{NAME};
}

method sex( $value = undef ) {
	$self->{SEX} = $value if defined $value;
	return $self->{SEX};
}

method age( $value = undef ) {
	$self->{AGE} = $value if defined $value;
	return $self->{AGE};
}

method as_string
{
	my $class = ref($self);
	my $name = $self->name;
	my $age = $self->age;
	my $sex = $self->sex;
	return "$class( name=$name, age=$age, sex=$sex )";
}

# stringification
use overload '""' => \&overload_as_string;
fun overload_as_string( $list, $x, $y )    # don’t care about last 2 params
{
	return $list->as_string;
}

1;
